import{s as Ht,n as Nt,o as Ct}from"../chunks/scheduler.0219f8bd.js";import{S as Mt,i as Lt,g as d,s,r as a,A as Et,h as l,f as n,c as i,j as u,u as p,x as c,k as r,y as gt,a as o,v as m,d as f,t as x,w as b}from"../chunks/index.f61edf3b.js";import{C as jt}from"../chunks/CodeBlock.38e566ae.js";import{H as h,E as Ot}from"../chunks/EditOnGithub.48fa589f.js";function It(dt){let v,se,ne,ie,k,de,$,le,T,lt=`Handler file for choosing the correct version of ONNX Runtime, based on the environment.
Ideally, we could import the <code>onnxruntime-web</code> and <code>onnxruntime-node</code> packages only when needed,
but dynamic imports don’t seem to work with the current webpack version and/or configuration.
This is possibly due to the experimental nature of top-level await statements.
So, we just import both packages, and use the appropriate one based on the environment:`,ce,_,ct="<li>When running in node, we use <code>onnxruntime-node</code>.</li> <li>When running in the browser, we use <code>onnxruntime-web</code> (<code>onnxruntime-node</code> is not bundled).</li>",re,P,rt="This module is not directly exported, but can be accessed through the environment variables:",ae,w,ue,y,at='<li><a href="#module_backends/onnx">backends/onnx</a><ul><li><em>static</em><ul><li><a href="#module_backends/onnx.deviceToExecutionProviders"><code>.deviceToExecutionProviders([device])</code></a> ⇒ <code>*</code></li> <li><a href="#module_backends/onnx.createInferenceSession"><code>.createInferenceSession(buffer, session_options)</code></a> ⇒ <code>*</code></li> <li><a href="#module_backends/onnx.isONNXTensor"><code>.isONNXTensor(x)</code></a> ⇒ <code>boolean</code></li> <li><a href="#module_backends/onnx.isONNXProxy"><code>.isONNXProxy()</code></a> ⇒ <code>boolean</code></li></ul></li> <li><em>inner</em><ul><li><a href="#module_backends/onnx..defaultExecutionProviders"><code>~defaultExecutionProviders</code></a> : <code>*</code></li> <li><a href="#module_backends/onnx..wasmInitPromise"><code>~wasmInitPromise</code></a> : <code>Promise&lt;any&gt;</code> | <code>null</code></li> <li><a href="#module_backends/onnx..supportedExecutionProviders"><code>~supportedExecutionProviders</code></a> : <code>*</code></li></ul></li></ul></li>',pe,me,fe,H,xe,N,be,C,ut="Map a device to the execution providers to use for the given device.",ve,M,pt='<strong>Kind</strong>: static method of <a href="#module_backends/onnx"><code>backends/onnx</code></a><br/> <strong>Returns</strong>: <code>*</code> - The execution providers to use for the given device.',he,L,mt="<thead><tr><th>Param</th><th>Type</th><th>Default</th><th>Description</th></tr></thead> <tbody><tr><td>[device]</td><td><code>*</code></td><td><code></code></td><td><p>(Optional) The device to run the inference on.</p></td></tr></tbody>",ke,$e,Te,E,_e,g,Pe,j,ft="Create an ONNX inference session.",we,O,xt='<strong>Kind</strong>: static method of <a href="#module_backends/onnx"><code>backends/onnx</code></a><br/> <strong>Returns</strong>: <code>*</code> - The ONNX inference session.',ye,I,bt="<thead><tr><th>Param</th><th>Type</th><th>Description</th></tr></thead> <tbody><tr><td>buffer</td><td><code>Uint8Array</code></td><td><p>The ONNX model buffer.</p></td> </tr><tr><td>session_options</td><td><code>Object</code></td><td><p>ONNX inference session options.</p></td></tr></tbody>",He,Ne,Ce,X,Me,A,Le,R,vt="Check if an object is an ONNX tensor.",Ee,S,ht='<strong>Kind</strong>: static method of <a href="#module_backends/onnx"><code>backends/onnx</code></a><br/> <strong>Returns</strong>: <code>boolean</code> - Whether the object is an ONNX tensor.',ge,W,kt="<thead><tr><th>Param</th><th>Type</th><th>Description</th></tr></thead> <tbody><tr><td>x</td><td><code>any</code></td><td><p>The object to check</p></td></tr></tbody>",je,Oe,Ie,J,Xe,K,Ae,Z,$t="Check if ONNX’s WASM backend is being proxied.",Re,U,Tt='<strong>Kind</strong>: static method of <a href="#module_backends/onnx"><code>backends/onnx</code></a><br/> <strong>Returns</strong>: <code>boolean</code> - Whether ONNX’s WASM backend is being proxied.',Se,We,Je,z,Ke,B,Ze,D,_t='<strong>Kind</strong>: inner property of <a href="#module_backends/onnx"><code>backends/onnx</code></a>',Ue,ze,Be,q,De,F,qe,Y,Pt=`To prevent multiple calls to <code>initWasm()</code>, we store the first call in a Promise
that is resolved when the first InferenceSession is created. Subsequent calls
will wait for this Promise to resolve before creating their own InferenceSession.`,Fe,V,wt='<strong>Kind</strong>: inner property of <a href="#module_backends/onnx"><code>backends/onnx</code></a>',Ye,Ve,Ge,G,Qe,Q,et,ee,yt='<strong>Kind</strong>: inner constant of <a href="#module_backends/onnx"><code>backends/onnx</code></a>',tt,nt,ot,te,st,oe,it;return $=new h({props:{title:"backends/onnx",local:"backendsonnx",headingTag:"h1"}}),w=new jt({props:{code:"aW1wb3J0JTIwJTdCJTIwZW52JTIwJTdEJTIwZnJvbSUyMCclNDBodWdnaW5nZmFjZSUyRnRyYW5zZm9ybWVycyclM0IlMEFjb25zb2xlLmxvZyhlbnYuYmFja2VuZHMub25ueCklM0I=",highlighted:`<span class="hljs-keyword">import</span> { env } <span class="hljs-keyword">from</span> <span class="hljs-string">&#x27;@huggingface/transformers&#x27;</span>;
<span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(env.<span class="hljs-property">backends</span>.<span class="hljs-property">onnx</span>);`,wrap:!1}}),N=new h({props:{title:"backends/onnx.deviceToExecutionProviders([device]) ⇒ <code> * </code>",local:"backendsonnxdevicetoexecutionprovidersdevice--code--code",headingTag:"h2"}}),g=new h({props:{title:"backends/onnx.createInferenceSession(buffer, session_options) ⇒ <code> * </code>",local:"backendsonnxcreateinferencesessionbuffer-sessionoptions--code--code",headingTag:"h2"}}),A=new h({props:{title:"backends/onnx.isONNXTensor(x) ⇒ <code> boolean </code>",local:"backendsonnxisonnxtensorx--code-boolean-code",headingTag:"h2"}}),K=new h({props:{title:"backends/onnx.isONNXProxy() ⇒ <code> boolean </code>",local:"backendsonnxisonnxproxy--code-boolean-code",headingTag:"h2"}}),B=new h({props:{title:"backends/onnx~defaultExecutionProviders : <code> * </code>",local:"backendsonnxdefaultexecutionproviders--code--code",headingTag:"h2"}}),F=new h({props:{title:"backends/onnx~wasmInitPromise : <code> Promise < any > </code> | <code> null </code>",local:"backendsonnxwasminitpromise--code-promise--any--code--code-null-code",headingTag:"h2"}}),Q=new h({props:{title:"backends/onnx~supportedExecutionProviders : <code> * </code>",local:"backendsonnxsupportedexecutionproviders--code--code",headingTag:"h2"}}),te=new Ot({props:{source:"https://github.com/xenova/transformers.js/blob/main/docs/source/api/backends/onnx.md"}}),{c(){v=d("meta"),se=s(),ne=d("p"),ie=s(),k=d("a"),de=s(),a($.$$.fragment),le=s(),T=d("p"),T.innerHTML=lt,ce=s(),_=d("ul"),_.innerHTML=ct,re=s(),P=d("p"),P.textContent=rt,ae=s(),a(w.$$.fragment),ue=s(),y=d("ul"),y.innerHTML=at,pe=s(),me=d("hr"),fe=s(),H=d("a"),xe=s(),a(N.$$.fragment),be=s(),C=d("p"),C.textContent=ut,ve=s(),M=d("p"),M.innerHTML=pt,he=s(),L=d("table"),L.innerHTML=mt,ke=s(),$e=d("hr"),Te=s(),E=d("a"),_e=s(),a(g.$$.fragment),Pe=s(),j=d("p"),j.textContent=ft,we=s(),O=d("p"),O.innerHTML=xt,ye=s(),I=d("table"),I.innerHTML=bt,He=s(),Ne=d("hr"),Ce=s(),X=d("a"),Me=s(),a(A.$$.fragment),Le=s(),R=d("p"),R.textContent=vt,Ee=s(),S=d("p"),S.innerHTML=ht,ge=s(),W=d("table"),W.innerHTML=kt,je=s(),Oe=d("hr"),Ie=s(),J=d("a"),Xe=s(),a(K.$$.fragment),Ae=s(),Z=d("p"),Z.textContent=$t,Re=s(),U=d("p"),U.innerHTML=Tt,Se=s(),We=d("hr"),Je=s(),z=d("a"),Ke=s(),a(B.$$.fragment),Ze=s(),D=d("p"),D.innerHTML=_t,Ue=s(),ze=d("hr"),Be=s(),q=d("a"),De=s(),a(F.$$.fragment),qe=s(),Y=d("p"),Y.innerHTML=Pt,Fe=s(),V=d("p"),V.innerHTML=wt,Ye=s(),Ve=d("hr"),Ge=s(),G=d("a"),Qe=s(),a(Q.$$.fragment),et=s(),ee=d("p"),ee.innerHTML=yt,tt=s(),nt=d("hr"),ot=s(),a(te.$$.fragment),st=s(),oe=d("p"),this.h()},l(e){const t=Et("svelte-u9bgzb",document.head);v=l(t,"META",{name:!0,content:!0}),t.forEach(n),se=i(e),ne=l(e,"P",{}),u(ne).forEach(n),ie=i(e),k=l(e,"A",{id:!0,class:!0}),u(k).forEach(n),de=i(e),p($.$$.fragment,e),le=i(e),T=l(e,"P",{"data-svelte-h":!0}),c(T)!=="svelte-1nskovu"&&(T.innerHTML=lt),ce=i(e),_=l(e,"UL",{"data-svelte-h":!0}),c(_)!=="svelte-1nim9s8"&&(_.innerHTML=ct),re=i(e),P=l(e,"P",{"data-svelte-h":!0}),c(P)!=="svelte-m4kxqp"&&(P.textContent=rt),ae=i(e),p(w.$$.fragment,e),ue=i(e),y=l(e,"UL",{"data-svelte-h":!0}),c(y)!=="svelte-1b3k5j4"&&(y.innerHTML=at),pe=i(e),me=l(e,"HR",{}),fe=i(e),H=l(e,"A",{id:!0,class:!0}),u(H).forEach(n),xe=i(e),p(N.$$.fragment,e),be=i(e),C=l(e,"P",{"data-svelte-h":!0}),c(C)!=="svelte-g2kkoo"&&(C.textContent=ut),ve=i(e),M=l(e,"P",{"data-svelte-h":!0}),c(M)!=="svelte-hryt3x"&&(M.innerHTML=pt),he=i(e),L=l(e,"TABLE",{"data-svelte-h":!0}),c(L)!=="svelte-15mkoxu"&&(L.innerHTML=mt),ke=i(e),$e=l(e,"HR",{}),Te=i(e),E=l(e,"A",{id:!0,class:!0}),u(E).forEach(n),_e=i(e),p(g.$$.fragment,e),Pe=i(e),j=l(e,"P",{"data-svelte-h":!0}),c(j)!=="svelte-19a590t"&&(j.textContent=ft),we=i(e),O=l(e,"P",{"data-svelte-h":!0}),c(O)!=="svelte-17jc8ku"&&(O.innerHTML=xt),ye=i(e),I=l(e,"TABLE",{"data-svelte-h":!0}),c(I)!=="svelte-1xknvln"&&(I.innerHTML=bt),He=i(e),Ne=l(e,"HR",{}),Ce=i(e),X=l(e,"A",{id:!0,class:!0}),u(X).forEach(n),Me=i(e),p(A.$$.fragment,e),Le=i(e),R=l(e,"P",{"data-svelte-h":!0}),c(R)!=="svelte-11755yo"&&(R.textContent=vt),Ee=i(e),S=l(e,"P",{"data-svelte-h":!0}),c(S)!=="svelte-1vudgod"&&(S.innerHTML=ht),ge=i(e),W=l(e,"TABLE",{"data-svelte-h":!0}),c(W)!=="svelte-o3zzgy"&&(W.innerHTML=kt),je=i(e),Oe=l(e,"HR",{}),Ie=i(e),J=l(e,"A",{id:!0,class:!0}),u(J).forEach(n),Xe=i(e),p(K.$$.fragment,e),Ae=i(e),Z=l(e,"P",{"data-svelte-h":!0}),c(Z)!=="svelte-bsb3mu"&&(Z.textContent=$t),Re=i(e),U=l(e,"P",{"data-svelte-h":!0}),c(U)!=="svelte-ha6bkx"&&(U.innerHTML=Tt),Se=i(e),We=l(e,"HR",{}),Je=i(e),z=l(e,"A",{id:!0,class:!0}),u(z).forEach(n),Ke=i(e),p(B.$$.fragment,e),Ze=i(e),D=l(e,"P",{"data-svelte-h":!0}),c(D)!=="svelte-jxwmib"&&(D.innerHTML=_t),Ue=i(e),ze=l(e,"HR",{}),Be=i(e),q=l(e,"A",{id:!0,class:!0}),u(q).forEach(n),De=i(e),p(F.$$.fragment,e),qe=i(e),Y=l(e,"P",{"data-svelte-h":!0}),c(Y)!=="svelte-mqeide"&&(Y.innerHTML=Pt),Fe=i(e),V=l(e,"P",{"data-svelte-h":!0}),c(V)!=="svelte-jxwmib"&&(V.innerHTML=wt),Ye=i(e),Ve=l(e,"HR",{}),Ge=i(e),G=l(e,"A",{id:!0,class:!0}),u(G).forEach(n),Qe=i(e),p(Q.$$.fragment,e),et=i(e),ee=l(e,"P",{"data-svelte-h":!0}),c(ee)!=="svelte-1djwi16"&&(ee.innerHTML=yt),tt=i(e),nt=l(e,"HR",{}),ot=i(e),p(te.$$.fragment,e),st=i(e),oe=l(e,"P",{}),u(oe).forEach(n),this.h()},h(){r(v,"name","hf:doc:metadata"),r(v,"content",Xt),r(k,"id","module_backends/onnx"),r(k,"class","group"),r(H,"id","module_backends/onnx.deviceToExecutionProviders"),r(H,"class","group"),r(E,"id","module_backends/onnx.createInferenceSession"),r(E,"class","group"),r(X,"id","module_backends/onnx.isONNXTensor"),r(X,"class","group"),r(J,"id","module_backends/onnx.isONNXProxy"),r(J,"class","group"),r(z,"id","module_backends/onnx..defaultExecutionProviders"),r(z,"class","group"),r(q,"id","module_backends/onnx..wasmInitPromise"),r(q,"class","group"),r(G,"id","module_backends/onnx..supportedExecutionProviders"),r(G,"class","group")},m(e,t){gt(document.head,v),o(e,se,t),o(e,ne,t),o(e,ie,t),o(e,k,t),o(e,de,t),m($,e,t),o(e,le,t),o(e,T,t),o(e,ce,t),o(e,_,t),o(e,re,t),o(e,P,t),o(e,ae,t),m(w,e,t),o(e,ue,t),o(e,y,t),o(e,pe,t),o(e,me,t),o(e,fe,t),o(e,H,t),o(e,xe,t),m(N,e,t),o(e,be,t),o(e,C,t),o(e,ve,t),o(e,M,t),o(e,he,t),o(e,L,t),o(e,ke,t),o(e,$e,t),o(e,Te,t),o(e,E,t),o(e,_e,t),m(g,e,t),o(e,Pe,t),o(e,j,t),o(e,we,t),o(e,O,t),o(e,ye,t),o(e,I,t),o(e,He,t),o(e,Ne,t),o(e,Ce,t),o(e,X,t),o(e,Me,t),m(A,e,t),o(e,Le,t),o(e,R,t),o(e,Ee,t),o(e,S,t),o(e,ge,t),o(e,W,t),o(e,je,t),o(e,Oe,t),o(e,Ie,t),o(e,J,t),o(e,Xe,t),m(K,e,t),o(e,Ae,t),o(e,Z,t),o(e,Re,t),o(e,U,t),o(e,Se,t),o(e,We,t),o(e,Je,t),o(e,z,t),o(e,Ke,t),m(B,e,t),o(e,Ze,t),o(e,D,t),o(e,Ue,t),o(e,ze,t),o(e,Be,t),o(e,q,t),o(e,De,t),m(F,e,t),o(e,qe,t),o(e,Y,t),o(e,Fe,t),o(e,V,t),o(e,Ye,t),o(e,Ve,t),o(e,Ge,t),o(e,G,t),o(e,Qe,t),m(Q,e,t),o(e,et,t),o(e,ee,t),o(e,tt,t),o(e,nt,t),o(e,ot,t),m(te,e,t),o(e,st,t),o(e,oe,t),it=!0},p:Nt,i(e){it||(f($.$$.fragment,e),f(w.$$.fragment,e),f(N.$$.fragment,e),f(g.$$.fragment,e),f(A.$$.fragment,e),f(K.$$.fragment,e),f(B.$$.fragment,e),f(F.$$.fragment,e),f(Q.$$.fragment,e),f(te.$$.fragment,e),it=!0)},o(e){x($.$$.fragment,e),x(w.$$.fragment,e),x(N.$$.fragment,e),x(g.$$.fragment,e),x(A.$$.fragment,e),x(K.$$.fragment,e),x(B.$$.fragment,e),x(F.$$.fragment,e),x(Q.$$.fragment,e),x(te.$$.fragment,e),it=!1},d(e){e&&(n(se),n(ne),n(ie),n(k),n(de),n(le),n(T),n(ce),n(_),n(re),n(P),n(ae),n(ue),n(y),n(pe),n(me),n(fe),n(H),n(xe),n(be),n(C),n(ve),n(M),n(he),n(L),n(ke),n($e),n(Te),n(E),n(_e),n(Pe),n(j),n(we),n(O),n(ye),n(I),n(He),n(Ne),n(Ce),n(X),n(Me),n(Le),n(R),n(Ee),n(S),n(ge),n(W),n(je),n(Oe),n(Ie),n(J),n(Xe),n(Ae),n(Z),n(Re),n(U),n(Se),n(We),n(Je),n(z),n(Ke),n(Ze),n(D),n(Ue),n(ze),n(Be),n(q),n(De),n(qe),n(Y),n(Fe),n(V),n(Ye),n(Ve),n(Ge),n(G),n(Qe),n(et),n(ee),n(tt),n(nt),n(ot),n(st),n(oe)),n(v),b($,e),b(w,e),b(N,e),b(g,e),b(A,e),b(K,e),b(B,e),b(F,e),b(Q,e),b(te,e)}}}const Xt='{"title":"backends/onnx","local":"backendsonnx","sections":[{"title":"backends/onnx.deviceToExecutionProviders([device]) ⇒ <code> * </code>","local":"backendsonnxdevicetoexecutionprovidersdevice--code--code","sections":[],"depth":2},{"title":"backends/onnx.createInferenceSession(buffer, session_options) ⇒ <code> * </code>","local":"backendsonnxcreateinferencesessionbuffer-sessionoptions--code--code","sections":[],"depth":2},{"title":"backends/onnx.isONNXTensor(x) ⇒ <code> boolean </code>","local":"backendsonnxisonnxtensorx--code-boolean-code","sections":[],"depth":2},{"title":"backends/onnx.isONNXProxy() ⇒ <code> boolean </code>","local":"backendsonnxisonnxproxy--code-boolean-code","sections":[],"depth":2},{"title":"backends/onnx~defaultExecutionProviders : <code> * </code>","local":"backendsonnxdefaultexecutionproviders--code--code","sections":[],"depth":2},{"title":"backends/onnx~wasmInitPromise : <code> Promise < any > </code> | <code> null </code>","local":"backendsonnxwasminitpromise--code-promise--any--code--code-null-code","sections":[],"depth":2},{"title":"backends/onnx~supportedExecutionProviders : <code> * </code>","local":"backendsonnxsupportedexecutionproviders--code--code","sections":[],"depth":2}],"depth":1}';function At(dt){return Ct(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Kt extends Mt{constructor(v){super(),Lt(this,v,At,It,Ht,{})}}export{Kt as component};
